#############################################################################
##
#A  init.g                  CrystGap library                     Bettina Eick
#A                                                              Franz G"ahler
#A                                                              Werner Nickel
##
#Y  Copyright 1990-1997,  Lehrstuhl D fuer Mathematik,  RWTH Aachen,  Germany
##
##  CrystGap - the crystallographic groups package for GAP (initialization)
##  

#############################################################################
##
##  Initialization of CrystGap
##

if not QUIET and BANNER then PrintPkgInit("cryst","1997");fi;
#############################################################################
##
##  Read the main functions immediately
##
ReadPkg( "cryst", "lib", "cryst" );
ReadPkg( "cryst", "lib", "cryst2" );

#############################################################################
##
##  Load color group support if needed
##
AUTO( ReadPkg( "cryst", "lib", "color" ),
      IsColorGroup, ColorSubgroup, ColorCosets, ColorOfElement, 
      ColorPermGroup, ColorHomomorphism, ColoredSubGroup,
      ColoredPointGroup, ColorGroup );

#############################################################################
##
##  Load Wyckoff lattice support if needed
##
AUTO( ReadPkg( "cryst", "lib", "wylat" ),
      IsSubspaceAffineSubspace, WyckoffPosRelations, 
      WyckoffLatticeRecord, WyckoffLattice );

